<template>
  <basic-container>
    <avue-crud :option="option"
               :table-loading="loading"
               :data="data"
               :page="page"
               :permission="permissionList"
               :before-open="beforeOpen"
               v-model="form"
               ref="crud"
               @row-update="rowUpdate"
               @row-save="rowSave"
               @row-del="rowDel"
               @search-change="searchChange"
               @search-reset="searchReset"
               @selection-change="selectionChange"
               @current-change="currentChange"
               @size-change="sizeChange"
               @refresh-change="refreshChange"
               @on-load="onLoad">
      <template slot="menuLeft">
        <el-button type="danger"
                   size="small"
                   icon="el-icon-delete"
                   plain
                   v-if="permission.facedevice_delete"
                   @click="handleDelete">删 除
        </el-button>
      </template>
      <template slot="mapSelectForm" slot-scope="scope">
        <!-- <avue-map v-model="scope.row.mapSelect"></avue-map> -->
        <div>
          <el-button @click="mapVisible = true">选择地址</el-button>

          <el-dialog :append-to-body="true" :close-on-click-modal="false" :modal-append-to-body="false" :visible.sync="mapVisible"
                     title="编辑地址" width="80%">
<!--            <customAvueMap v-if="mapVisible" v-model="scope.row.mapSelect"></customAvueMap>-->
            <editPolygonMap v-if="mapVisible" :editForm.sync="scope.row" :visible.sync="mapVisible"></editPolygonMap>
          </el-dialog>
        </div>
      </template>
    </avue-crud>
  </basic-container>
</template>

<script>
  import {getList, getDetail, add, update, remove} from "../../api/device/doordevice.js";
  import {mapGetters} from "vuex";
  import customAvueMap from "../../components/residential/customAvueMap.vue"
  import editPolygonMap from "../../components/residential/editPolygonMap.vue";
  export default {
    components:{
      customAvueMap,editPolygonMap
    },
    data() {
      return {
        mapVisible:false,
        form: {},
        query: {},
        loading: true,
        page: {
          pageSize: 10,
          currentPage: 1,
          total: 0
        },
        selectionList: [],
        option: {
          height:'auto',
          calcHeight: 60,
          tip: false,
          searchShow: true,
          searchMenuSpan: 6,
          border: true,
          index: true,
          viewBtn: true,
          selection: true,
          dialogClickModal: false,
          menuWidth:350,
          column: [
            {
              label: "门禁设备",
              prop: "id",
              hide: true,
              display:false,
              rules: [{
                required: true,
                message: "请输入门禁设备",
                trigger: "blur"
              }]
            },
            // {
            //   label: "设备编号",
            //   prop: "cameraCode",
            //   width: 135,
            //   rules: [{
            //     required: true,
            //     message: "请输入设备编号",
            //     trigger: "blur"
            //   }]
            // },
            // {
            //   label: "名称",
            //   prop: "cameraName",
            //   search: true,
            //   overHidden: true,
            //   rules: [{
            //     required: true,
            //     message: "请输入名称",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "所属省",
              prop: "provinceCode",
              // hide: true,
              width: 150,
              type: "select",
              dicUrl: "/api/blade-system/region/lazy-tree?parentCode=000000",
              cascaderItem:["cityCode"],
              props:{
                label:"title",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请输入省行政编码",
                trigger: "blur"
              }]
            },
            {
              label: "所属市",
              prop: "cityCode",
              hide: true,
              type: "select",
              width: 100,
              cascaderItem: ["areaCode"],
              dicUrl: `/api/blade-system/region/lazy-tree?parentCode={{key}}`,
              props:{
                label: "title",
                value: "id"
              },
              // dicFlag: false,
              rules: [{
                required: true,
                message: "请输入市行政编码",
                trigger: "blur"
              }]
            },
            {
              label: "所属区",
              prop: "areaCode",
              type: "select",
              // width: 100,
              // dicFlag: false,
              cascaderItem: ["residentialId"],
              dicUrl: `/api/blade-system/region/lazy-tree?parentCode={{key}}`,
              props:{
                label: "title",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请输入区行政编码",
                trigger: "blur"
              }]
            },
            {
              label: "所属小区",
              prop: "residentialId",
              // slot: true,
              type: "select",
              search: true,
              searchFilterable: true,
              // dicUrl: "/api/cyzh-community/residential/list?size=900&regionArea={{key}}",
              dicUrl: "/api/cyzh-community/residential/list?size=900",
              dicFormatter:(res)=>{
                return res.data.records;//返回字典的层级结构
              },
              // dicFlag: false,
              filterable: true,
              props: {
                label: "name",
                value: "id"
              },
              rules: [{
                required: true,
                message: "请选择所属小区",
                trigger: "blur"
              }]
            },
            {
              label: "具体地址",
              prop: "address",
              width: 180,
              search: true,
              overHidden: true,
              rules: [{
                required: true,
                message: "请输入具体地址",
                trigger: "blur"
              }]
            },

            // {
            //   label: "Mac编码",
            //   prop: "macAddress",
            //   width: 110,
            //   rules: [{
            //     required: true,
            //     message: "请输入Mac编码",
            //     trigger: "blur"
            //   }]
            // },
            {
              label: "创建时间",
              prop: "createTime",
              display: false,
              width: 150,
              rules: [{
                required: true,
                message: "请输入创建时间",
                trigger: "blur"
              }]
            },
            {
              label: "设备状态",
              prop: "deviceStatus",
              type: "select",
              width: 80,
              dicUrl:"/api/blade-system/dict-biz/dictionary?code=face_device_status",
              props: {
                label: 'dictValue',
                value: 'dictKey'
              },
              dataType: "number",
              rules: [{
                required: true,
                message: "请输入设备状态：0-离线 2-mac异常",
                trigger: "blur"
              }]
            },
            {
              label:'',
              prop:'mapSelect',
              // row: true,
              // span: 20,
              formslot: true,
              hide: true,
            },
            {
              label: "经度",
              prop: "longitude",
              width: 100,
              overHidden: true,
              hide:true,
              rules: [{
                required: true,
                message: "请输入经度",
                trigger: "blur"
              }]
            },
            {
              label: "纬度",
              prop: "latitude",
              width: 100,
              overHidden: true,
              hide:true,
              rules: [{
                required: true,
                message: "请输入纬度",
                trigger: "blur"
              }]
            },



          ]
        },
        data: []
      };
    },
    computed: {
      ...mapGetters(["permission"]),
      permissionList() {
        return {
          addBtn: this.vaildData(this.permission.doordevice_add, false),
          viewBtn: this.vaildData(this.permission.doordevice_view, false),
          delBtn: this.vaildData(this.permission.doordevice_delete, false),
          editBtn: this.vaildData(this.permission.doordevice_edit, false)
        };
      },
      ids() {
        let ids = [];
        this.selectionList.forEach(ele => {
          ids.push(ele.id);
        });
        return ids.join(",");
      }
    },
    watch: {
      'form.mapSelect': {
        handler: function(value) {
          if (!value){
            return
          }else{
            this.form.longitude = this.form.mapSelect.longitude;
            this.form.latitude = this.form.mapSelect.latitude;
          }
        },
      }
    },
    mounted() {
      let tenantType = localStorage.getItem("tenantType");
      const residentialColumn = this.findObject(this.option.column, "residentialId");
      if (tenantType == 1) { //园区
        residentialColumn.label = "所属区域";
      } else { //社区
        residentialColumn.label = "所属小区";
      }
    },
    methods: {
      rowSave(row, done, loading) {
        add(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          window.console.log(error);
        });
      },
      rowUpdate(row, index, done, loading) {
        update(row).then(() => {
          this.onLoad(this.page);
          this.$message({
            type: "success",
            message: "操作成功!"
          });
          done();
        }, error => {
          loading();
          console.log(error);
        });
      },
      rowDel(row) {
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(row.id);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
          });
      },
      handleDelete() {
        if (this.selectionList.length === 0) {
          this.$message.warning("请选择至少一条数据");
          return;
        }
        this.$confirm("确定将选择数据删除?", {
          confirmButtonText: "确定",
          cancelButtonText: "取消",
          type: "warning"
        })
          .then(() => {
            return remove(this.ids);
          })
          .then(() => {
            this.onLoad(this.page);
            this.$message({
              type: "success",
              message: "操作成功!"
            });
            this.$refs.crud.toggleSelection();
          });
      },
      beforeOpen(done, type) {
        if (["edit", "view"].includes(type)) {
          getDetail(this.form.id).then(res => {
            this.form = res.data.data;
          });
        }
        done();
      },
      searchReset() {
        this.query = {};
        this.onLoad(this.page);
      },
      searchChange(params, done) {
        this.query = params;
        this.page.currentPage = 1;
        this.onLoad(this.page, params);
        done();
      },
      selectionChange(list) {
        this.selectionList = list;
      },
      selectionClear() {
        this.selectionList = [];
        this.$refs.crud.toggleSelection();
      },
      currentChange(currentPage){
        this.page.currentPage = currentPage;
      },
      sizeChange(pageSize){
        this.page.pageSize = pageSize;
      },
      refreshChange() {
        this.onLoad(this.page, this.query);
      },
      onLoad(page, params = {}) {
        this.loading = true;
        getList(page.currentPage, page.pageSize, Object.assign(params, this.query)).then(res => {
          const data = res.data.data;
          this.page.total = data.total;
          this.data = data.records;
          this.loading = false;
          this.selectionClear();
        });
      }
    }
  };
</script>

<style>
</style>
